﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace mergeSample.Models {
    public class DataContext {
        public List<rptSignInSheetReturnModel> rptSignInSheet(int district, int? workshopSectionID, int? workshopSectionSessionID, DateTime? beginDate, DateTime? endDate, bool includeNoRegistration) {
            var returnList = new List<rptSignInSheetReturnModel>();

            returnList.Add(new rptSignInSheetReturnModel() { UserID = 1, FirstName = "test1", LastName = "test1", EmployeeID = "1", RegistrationID = 1, WorkshopSectionID = 1, WorkshopSectionSessionID = 1, AttendanceHours = null, WorkLocation = "testLocation", District = 1, SessionDate = DateTime.Parse("2020-03-01"), WorkLocationName = "testLocation", CompensationType = "A" });
            returnList.Add(new rptSignInSheetReturnModel() { UserID = 2, FirstName = "test2", LastName = "test2", EmployeeID = "2", RegistrationID = 1, WorkshopSectionID = 1, WorkshopSectionSessionID = 1, AttendanceHours = null, WorkLocation = "testLocation", District = 1, SessionDate = DateTime.Parse("2020-03-01"), WorkLocationName = "testLocation", CompensationType = "A" });
            returnList.Add(new rptSignInSheetReturnModel() { UserID = 3, FirstName = "test3", LastName = "test3", EmployeeID = "3", RegistrationID = 1, WorkshopSectionID = 1, WorkshopSectionSessionID = 1, AttendanceHours = null, WorkLocation = "testLocation", District = 1, SessionDate = DateTime.Parse("2020-03-01"), WorkLocationName = "testLocation", CompensationType = "A" });
            returnList.Add(new rptSignInSheetReturnModel() { UserID = 4, FirstName = "test4", LastName = "test4", EmployeeID = "4", RegistrationID = 1, WorkshopSectionID = 1, WorkshopSectionSessionID = 1, AttendanceHours = null, WorkLocation = "testLocation", District = 1, SessionDate = DateTime.Parse("2020-03-01"), WorkLocationName = "testLocation", CompensationType = "A" });
            returnList.Add(new rptSignInSheetReturnModel() { UserID = 5, FirstName = "test5", LastName = "test5", EmployeeID = "5", RegistrationID = 1, WorkshopSectionID = 1, WorkshopSectionSessionID = 1, AttendanceHours = null, WorkLocation = "testLocation", District = 1, SessionDate = DateTime.Parse("2020-03-01"), WorkLocationName = "testLocation", CompensationType = "A" });
            returnList.Add(new rptSignInSheetReturnModel() { UserID = 6, FirstName = "test6", LastName = "test6", EmployeeID = "6", RegistrationID = 1, WorkshopSectionID = 1, WorkshopSectionSessionID = 1, AttendanceHours = null, WorkLocation = "testLocation", District = 1, SessionDate = DateTime.Parse("2020-03-01"), WorkLocationName = "testLocation", CompensationType = "A" });

            return returnList;
        }

        public List<WorkshopSectionSessionsGetReturnModel> WorkshopSectionSessionsGet(int district, int? workshopSectionID, DateTime? beginDate, DateTime? endDate, bool includeNoRegistration) {
            var returnList = new List<WorkshopSectionSessionsGetReturnModel>();

            returnList.Add(new WorkshopSectionSessionsGetReturnModel() { WorkshopSectionSessionID = 1, DistrictName = "Test", WorkshopID = 1, WorkshopName = "test", CourseNumber = 1, SurveyRequirementID = 3, SurveyID = 1, WorkshopLocation = "TestLocation", WorkshopLocationDescription = "TestLocation", WorkshopDate = DateTime.Parse("2020-03-01"), WorkshopBegin = DateTime.Parse("2020-03-01 10:00:00.000"), WorkshopEnd = DateTime.Parse("2020-03-01 15:00:00.000") });

            return returnList;
        }

        public List<WorkshopSectionPresentersGetReturnModel> WorkshopSectionPresentersGet(int district, int? workshopSectionID, DateTime? beginDate, DateTime? endDate, bool includeNoRegistration) {
            var returnList = new List<WorkshopSectionPresentersGetReturnModel>();

            returnList.Add(new WorkshopSectionPresentersGetReturnModel() { WorkshopSectionID = 1, WorkshopSectionSessionID = 1, WorkshopSectionStaffID = 1, StaffID = 1, StaffTypeID = 1, NameFirst = "test1", NameLast = "test1", Title = "Test", UserID = 123, IsActive = 1 });

            return returnList;
        }

        public List<DistrictDefault> DistrictDefaults() {
            var returnList = new List<DistrictDefault>();

            returnList.Add(new DistrictDefault() { District = 1, DistrictName = "TestDistrict", IsEmployeeIDonSignInSheets = false });

            return returnList;
        }
    }


    public partial class rptSignInSheetReturnModel {
        public int? UserID { get; set; }
        public string FirstName { get; set; }
        public string LastName { get; set; }
        public string EmployeeID { get; set; }
        public int WorkshopSectionID { get; set; }
        public int WorkshopSectionSessionID { get; set; }
        public decimal? AttendanceHours { get; set; }
        public string WorkLocation { get; set; }
        public string WorkLocationName { get; set; }
        public int District { get; set; }
        public DateTime? SessionDate { get; set; }
        public int? RegistrationID { get; set; }
        public string CompensationType { get; set; }
    }

    public partial class WorkshopSectionSessionsGetReturnModel {
        public int WorkshopSectionSessionID { get; set; }
        public string DistrictName { get; set; }
        public int WorkshopID { get; set; }
        public string WorkshopName { get; set; }
        public int? CourseNumber { get; set; }
        public int? SurveyRequirementID { get; set; }
        public int? SurveyID { get; set; }
        public string WorkshopLocation { get; set; }
        public string WorkshopLocationDescription { get; set; }
        public DateTime? WorkshopDate { get; set; }
        public DateTime? WorkshopBegin { get; set; }
        public DateTime? WorkshopEnd { get; set; }
    }

    public partial class WorkshopSectionPresentersGetReturnModel {
        public int WorkshopSectionStaffID { get; set; }
        public int? WorkshopSectionID { get; set; }
        public int WorkshopSectionSessionID { get; set; }
        public int StaffID { get; set; }
        public int? StaffTypeID { get; set; }
        public int? UserID { get; set; }
        public string NameFirst { get; set; }
        public string NameLast { get; set; }
        public string Title { get; set; }
        public int? IsActive { get; set; }
    }

    public class DistrictDefault {
        public int District { get; set; }
        public string DistrictName { get; set; }

        public bool IsEmployeeIDonSignInSheets { get; set; }
    }
}
