﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace mergeSample.Models {
    public class SignInSheetMergeModel {
            public string DistrictName { get; set; }
            public int WorkshopID { get; set; }
            public string WorkshopName { get; set; }
            public int CourseNumber { get; set; }
            public string WorkshopLocation { get; set; }
            public string WorkshopLocationDescription { get; set; }
            public DateTime WorkshopDate { get; set; }
            public DateTime WorkshopBegin { get; set; }
            public DateTime WorkshopEnd { get; set; }
            public string SurveyURL { get; set; }
            public string TemplatePath { get; set; }

            public List<PresenterModel> PresenterList { get; set; }

            public List<AttendeeModel> Attendees { get; set; }

            public string Date {
                get {
                    return WorkshopDate.ToShortDateString();
                }
            }

            public string Location {
                get {
                    return $"{WorkshopLocation} - {WorkshopLocationDescription}";
                }
            }

            public string Presenters {
                get {
                    return string.Join(",", PresenterList.Select(s => s.FirstName + " " + s.LastName).ToArray());
                }
            }

            public string TimeRange {
                get {
                    return $"{WorkshopBegin.ToShortTimeString()} - {WorkshopEnd.ToShortTimeString()}";
                }
            }
        }
    }
