﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using mergeSample.Enums;
using mergeSample.Services;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;

namespace mergeSample.Pages {
    public class IndexModel : PageModel {
        private readonly ISignInSheetExportService _signInSheetExportService;

        [BindProperty]
        public int WorkshopSectionID { get; set; }

        [BindProperty]
        public int NumberOfPages { get; set; }

        public IndexModel(ISignInSheetExportService signInSheetExportService) {
            _signInSheetExportService = signInSheetExportService;
        }

        public void OnGet() {
            WorkshopSectionID = 1;
            //WorkshopSectionID = 86615;
        }

        public IActionResult OnPostAttendees() {
            var export = _signInSheetExportService.SignInSheetPDFGet(1, WorkshopSectionID, null, null, SignInSheetExportGroupBy.WorkshopSectionEmployee, false);

            var fileStream = new FileStreamResult(export, "application/pdf");
            fileStream.FileDownloadName = $"WorkshopSection{WorkshopSectionID}Registrations_{DateTime.Now.ToString("yyyyddMM")}.pdf";

            return fileStream;
        }

        public IActionResult OnPostBlankSheets() {
            var export = _signInSheetExportService.BlankSignInSheetsGet(1, NumberOfPages, WorkshopSectionID, null, null);

            var fileStream = new FileStreamResult(export, "application/pdf");
            fileStream.FileDownloadName = $"WorkshopSection{WorkshopSectionID}_{DateTime.Now.ToString("yyyyddMM")}.pdf";

            return fileStream;
        }

        public IActionResult OnPostGroupByLocation() {
            var export = _signInSheetExportService.SignInSheetPDFGet(1, WorkshopSectionID, null, null, SignInSheetExportGroupBy.WorkshopSectionLocationEmployee, false);

            var fileStream = new FileStreamResult(export, "application/pdf");
            fileStream.FileDownloadName = $"WorkshopSection{WorkshopSectionID}Registrations_{DateTime.Now.ToString("yyyyddMM")}.pdf";

            return fileStream;
        }
    }
}